import numpy as np
import random 
import graphviz
import pandas as pd
from matplotlib import pyplot as plt
from sklearn.preprocessing import StandardScaler, MinMaxScaler
from sklearn.metrics import classification_report
from keras.models import Sequential
from keras.layers import *
from keras.utils import to_categorical
from keras.optimizers import RMSprop, adam, SGD
from keras.utils.vis_utils import plot_model
#from data_retriever import data_retriever
#from data_extender import data_extender
#from timeseries_plotter import timeseries_plotter
#from account_plotter import account_plotter
class thruster_diagnosis:
    def __init__(self): #self?  self
        self.x_testsets = {}
        self.y_testsets = {} 
        self.variable_split = 0
        self.results_total = pd.DataFrame(columns=['No_Faults','Freeze_Port','Freeze_Bow','Freeze_Star',
                                                   'pred_no_Faults','pred_freeze_Port','pred_freeze_Bow','pred_freeze_Star'])

    
    # Warning: This function takes a while to finish, do not run it every run.
    # Instead, create and save the serialized model using Pickle. 
    def model_initialize(self, df_dictionary):
        num_datapoints = 0 
        
        ## Input shape to LSTM
        
        # Set batch size equal to the amount of time series
        batch_size_c = 14
        timesteps_look_back = 20
        input_dim = 35

        
        
        self.epochs = 1
        iterate = 1
        #total_epochs = epochs * len(datasets)
        epochs_done = 0
        self.dropout = 0.4
        set_names = ['NoFaults','NoFaults2','port_freeze_1','port_freeze_2',
                     'bow_freeze_1','bow_freeze_2',
                     'star_freeze_1','star_freeze_2', 'nofault3', 'port_freeze3',
                     'port_freeze4','bow_freeze3','star_freeze3','star_freeze4']
        #for k in datasets:
        break_flag = 0
        # Uncomment to shuffle        

        # cammi was here :) 
        #num_datapoints = datasets[k].shape[0] + num_datapoints
        
        


        # Padding to make the X-dimension of the tensor have equal lengths
        # The time series lacking samples will get padded with zeros. 
        
        # Find longest time series
        max_elem = 0
        for i in df_dictionary:
            df_dictionary[i].drop(columns=['Elapsed_time', 'Reached', 'Step'],inplace=True)
            if (df_dictionary[i].shape[0] > max_elem):
                max_elem = df_dictionary[i].shape[0]
                max_index = i
        
        print("Start padding")
        padding_row = pd.DataFrame(data=np.zeros(shape=(1,df_dictionary[0].shape[1])))
        padding_row.columns = df_dictionary[0].columns
        for k in df_dictionary:
            if((k != max_index) and (df_dictionary[k].shape[0] != max_elem)):
                while(df_dictionary[k].shape[0] < max_elem):
                    df_dictionary[k] = pd.concat((df_dictionary[k],padding_row),axis=0, ignore_index = True)
        print("Done padding!")


        # Feature Scaling
        x_scaled = {}
        scaler = MinMaxScaler(feature_range=(0, 1))
        for i in range(0,len(df_dictionary)):
            scaler = scaler.fit(df_dictionary[i].iloc[:,:input_dim])
            x_scaled[i] = scaler.transform(df_dictionary[i].iloc[:,:input_dim])
        
        xy_scaled = {}
        for i in range(0,len(df_dictionary)):
            xy_scaled[i] =  np.concatenate((x_scaled[i],df_dictionary[i].iloc[:,input_dim:]),axis=1)

        
        
        ## Create tensors containing all data
        
        datatensor = np.stack(list(xy_scaled.values()),axis=0)            
        x,y = np.split(datatensor,[input_dim],axis=2)
                
        split_num = 0.6#0.9
        train_elements = 0
        test_elements = 0 
        
        
        if(self.variable_split == 0): 
            if(break_flag):
                break_flag = 0
            else:
                deletedRows = 0
                split = int(x.shape[1]*split_num)
                train_elements = split
                test_elements = x.shape[1]-split
                while True: 
                    if ((train_elements%timesteps_look_back == 0) and (test_elements%timesteps_look_back == 0)):
                        print("Sets are now divisble by batch size - deleted " + str(deletedRows) +" rows")
                        break_flag = 1
                        break
                    x = np.delete(x,-1,axis=1)
                    y = np.delete(y,-1,axis=1)
                    split = int(x.shape[1]*split_num)
                    train_elements = split
                    test_elements = x.shape[1]-(split)
                    deletedRows = deletedRows + 1
        
        x_train, x_test, y_train, y_test = x[:,:split,:], x[:,split:,:], y[:,:split,:], y[:,split:,:]
        max_seq_length = x_train.shape[1]
        
        self.model = Sequential()
        # Masking makes the model skip padding samples (all features == 0)
        self.model.add(Masking(mask_value=0., input_shape=(None, input_dim)))
        self.model.add(LSTM(256,input_shape=(batch_size_c,timesteps_look_back, input_dim), dropout=self.dropout,return_sequences=True))
        self.model.add(LSTM(256, return_sequences=True,batch_size = batch_size_c,
                       input_shape=(timesteps_look_back, input_dim), dropout=self.dropout))
        self.model.add(TimeDistributed(Dense(1)))
        self.model.add(Dense(128, activation='linear'))
        self.model.add(Dropout(self.dropout))
        self.model.add(LeakyReLU(alpha=0.3))
        self.model.add(Dense(64, activation='linear'))
        self.model.add(Dropout(self.dropout))
        self.model.add(LeakyReLU(alpha=0.3))
        self.model.add(Dense(64, activation='linear'))
        self.model.add(Dropout(self.dropout))
        self.model.add(LeakyReLU(alpha=0.3))
        self.model.add(Dense(4, activation='softmax')) 
        opt = RMSprop(lr=0.001)
        #opt = adam(lr=0.0016)
        self.model.compile(loss='categorical_crossentropy', optimizer=opt, metrics=['accuracy'])

        self.herstory = self.model.fit(x_train, y_train, epochs=self.epochs, batch_size=batch_size_c,verbose=2, shuffle=False, validation_data=(x_test, y_test))



        
        y_pred = self.model.predict(x_test,batch_size=batch_size_c)
        y_pred = (y_pred > 0.5)
        if(k == 3):
            print("No. 2")
        for i in df_dictionary:
            data = {'No_Faults': y_test[i,:,0],'Freeze_Port': y_test[i,:,1], 'Freeze_Bow': y_test[i,:,2],'Freeze_Star': y_test[i,:,3], 'pred_no_Faults': y_pred[i,:,0],'pred_freeze_Port': y_pred[i,:,1], 'pred_freeze_Bow': y_pred[i,:,2],
                    'pred_freeze_Star': y_pred[i,:,3]}
            results = pd.DataFrame(data = data)
            self.results_total = self.results_total.append(results,ignore_index=True)
        
        self.model.summary()
        plot_model(self.model, to_file='model_plot.png', show_shapes=True, show_layer_names=True)




if (__name__ == '__main__'):
    random.seed(42)
    df_dictionary = {}
    
    df_dictionary[0] = pd.read_csv('trainingdata_nofault_fixed.csv', encoding = "ISO-8859-1").iloc[:,1:]
    df_dictionary[1] = pd.read_csv('trainingdata_nofault2_fixed.csv', encoding = "ISO-8859-1").iloc[:,1:]
    df_dictionary[2] = pd.read_csv('trainingdata_port_freeze_fixed.csv', encoding = "ISO-8859-1").iloc[:,1:]
    df_dictionary[3] = pd.read_csv('trainingdata_port_freeze2_fixed.csv', encoding = "ISO-8859-1").iloc[:,1:]
    df_dictionary[4] = pd.read_csv('trainingdata_bow_freeze_fixed.csv', encoding = "ISO-8859-1").iloc[:,1:]
    df_dictionary[5] = pd.read_csv('trainingdata_bow_freeze2_fixed.csv', encoding = "ISO-8859-1").iloc[:,1:]
    df_dictionary[6] = pd.read_csv('trainingdata_star_freeze_fixed.csv', encoding = "ISO-8859-1").iloc[:,1:]
    df_dictionary[7] = pd.read_csv('trainingdata_star_freeze2_fixed.csv', encoding = "ISO-8859-1").iloc[:,1:]
    
    
    df_dictionary[8] = pd.read_csv('trainingdata_nofault3.csv', encoding = "ISO-8859-1")
    df_dictionary[9] = pd.read_csv('trainingdata_port_freeze_3.csv', encoding = "ISO-8859-1")
    df_dictionary[10] = pd.read_csv('trainingdata_port_freeze_4.csv', encoding = "ISO-8859-1")
    df_dictionary[11] = pd.read_csv('trainingdata_bow_freeze_4.csv', encoding = "ISO-8859-1")
    df_dictionary[12] = pd.read_csv('trainingdata_star_freeze_3.csv', encoding = "ISO-8859-1")
    df_dictionary[13] = pd.read_csv('trainingdata_star_freeze_4.csv', encoding = "ISO-8859-1")





    ann = thruster_diagnosis()
    ann.model_initialize(df_dictionary)
    
    
    plt.plot(ann.herstory.history['acc'])
    #plt.plot(ann.herstory.history['val_acc'])
    plt.title('model accuracy')
    plt.ylabel('accuracy')
    plt.xlabel('epoch')
    plt.legend(['train'], loc='upper left')
    plt.show()
    
    plt.plot(ann.herstory.history['loss'])
    #plt.plot(ann.herstory.history['val_loss'])
    plt.title('model loss')
    plt.ylabel('loss')
    plt.xlabel('epoch')
    plt.legend(['train'], loc='upper left')
    plt.show()
    
    plt.plot(ann.herstory.history['acc'])
    plt.plot(ann.herstory.history['val_acc'])
    plt.title('model accuracy')
    plt.ylabel('accuracy')
    plt.xlabel('epoch')
    plt.legend(['train','test'], loc='upper left')
    plt.show()
    
    plt.plot(ann.herstory.history['loss'])
    plt.plot(ann.herstory.history['val_loss'])
    plt.title('model loss')
    plt.ylabel('loss')
    plt.xlabel('epoch')
    plt.legend(['train','test'], loc='upper left')
    plt.show()